Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ boot/Makefile.common	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -62,5 +62,4 @@
 	$(USPACEDIR)/app/getterm/getterm \
 	$(USPACEDIR)/app/klog/klog \
-	$(USPACEDIR)/app/mkfat/mkfat \
 	$(USPACEDIR)/app/redir/redir \
 	$(USPACEDIR)/app/tester/tester \
Index: kernel/Makefile.build
===================================================================
--- kernel/Makefile.build	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/Makefile.build	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -186,5 +186,4 @@
 	generic/src/ddi/device.c \
 	generic/src/debug/symtab.c \
-	generic/src/debug/stacktrace.c \
 	generic/src/interrupt/interrupt.c \
 	generic/src/main/main.c \
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -38,5 +38,5 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-CMN1 = -m64 -mcmodel=kernel -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
+CMN1 = -m64 -mcmodel=kernel -mno-red-zone -fno-unwind-tables
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
@@ -60,6 +60,4 @@
 	arch/$(KARCH)/src/boot/boot.S \
 	arch/$(KARCH)/src/boot/memmap.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/pm.c \
 	arch/$(KARCH)/src/context.S \
Index: kernel/arch/amd64/_link.ld.in
===================================================================
--- kernel/arch/amd64/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -44,5 +44,4 @@
 		*(COMMON);		/* global variables */
 
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);            /* Symbol table, must be LAST symbol!*/
Index: kernel/arch/amd64/include/context.h
===================================================================
--- kernel/arch/amd64/include/context.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/include/context.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -46,11 +46,4 @@
 #define SP_DELTA     16
 
-#define context_set(c, _pc, stack, size) \
-	do { \
-		(c)->pc = (uintptr_t) (_pc); \
-		(c)->sp = ((uintptr_t) (stack)) + (size) - SP_DELTA; \
-		(c)->rbp = 0; \
-	} while (0)
-
 #endif /* KERNEL */
 
Index: kernel/arch/amd64/include/interrupt.h
===================================================================
--- kernel/arch/amd64/include/interrupt.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/include/interrupt.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -70,5 +70,5 @@
 
 /** This is passed to interrupt handlers */
-typedef struct istate {
+typedef struct {
 	uint64_t rax;
 	uint64_t rcx;
@@ -80,5 +80,4 @@
 	uint64_t r10;
 	uint64_t r11;
-	uint64_t rbp;
 	uint64_t error_word;
 	uint64_t rip;
@@ -102,8 +101,4 @@
 	return istate->rip;
 }
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return istate->rbp;
-}
 
 extern void (* disable_irqs_function)(uint16_t irqmask);
Index: kernel/arch/amd64/src/asm_utils.S
===================================================================
--- kernel/arch/amd64/src/asm_utils.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/src/asm_utils.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -27,5 +27,5 @@
 #
 
-#define IREGISTER_SPACE	80
+#define IREGISTER_SPACE	72 
 
 #define IOFFSET_RAX	0x0
@@ -38,5 +38,4 @@
 #define IOFFSET_R10	0x38
 #define IOFFSET_R11	0x40
-#define IOFFSET_RBP	0x48
 
 #  Mask for interrupts 0 - 31 (bits 0 - 31) where 0 means that int has no error word
@@ -180,5 +179,4 @@
 	movq %r10, IOFFSET_R10(%rsp)
 	movq %r11, IOFFSET_R11(%rsp)
-	movq %rbp, IOFFSET_RBP(%rsp)
 .endm
 
@@ -193,5 +191,4 @@
 	movq IOFFSET_R10(%rsp), %r10
 	movq IOFFSET_R11(%rsp), %r11
-	movq IOFFSET_RBP(%rsp), %rbp
 .endm
 
@@ -238,7 +235,4 @@
 	cld
 
-	# Stop stack traces here
-	xorq %rbp, %rbp
-
 	movq $(\i), %rdi   	# %rdi - first parameter
 	movq %rsp, %rsi   	# %rsi - pointer to istate
Index: kernel/arch/amd64/src/boot/boot.S
===================================================================
--- kernel/arch/amd64/src/boot/boot.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/src/boot/boot.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -174,8 +174,4 @@
 	call arch_pre_main
 	
-	# create the first stack frame
-	pushq $0
-	movq %rsp, %rbp
-
 	call main_bsp
 	
@@ -333,11 +329,11 @@
 
 extended_cpuid_msg:
-	.asciz "Error: Extended CPUID not supported -- CPU is not 64-bit. System halted."
+	.asciz "Extended CPUID not supported. System halted."
 long_mode_msg:
-	.asciz "Error: 64-bit long mode not supported. System halted."
+	.asciz "64 bit long mode not supported. System halted."
 noexecute_msg:
-	.asciz "Error: No-execute pages not supported. System halted."
+	.asciz "No-execute pages not supported. System halted."
 fx_msg:
-	.asciz "Error: FXSAVE/FXRESTORE instructions not supported. System halted."
+	.asciz "FXSAVE/FXRESTORE instructions not supported. System halted."
 sse2_msg:
-	.asciz "Error: SSE2 instructions not supported. System halted."
+	.asciz "SSE2 instructions not supported. System halted."
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/src/interrupt.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -53,5 +53,4 @@
 #include <ddi/irq.h>
 #include <symtab.h>
-#include <stacktrace.h>
 
 /*
@@ -81,6 +80,4 @@
 	    istate->r10, istate->r11);
 	printf("%%rsp=%#llx\n", &istate->stack[0]);
-	
-	stack_trace_istate(istate);
 }
 
Index: kernel/arch/amd64/src/mm/page.c
===================================================================
--- kernel/arch/amd64/src/mm/page.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/src/mm/page.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -203,6 +203,5 @@
 {
 	if (last_frame + ALIGN_UP(size, PAGE_SIZE) > KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH))
-		panic("Unable to map physical memory %p (%d bytes).", physaddr,
-		    size);
+		panic("Unable to map physical memory %p (%d bytes).", physaddr, size)
 	
 	uintptr_t virtaddr = PA2KA(last_frame);
Index: kernel/arch/amd64/src/smp/ap.S
===================================================================
--- kernel/arch/amd64/src/smp/ap.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/amd64/src/smp/ap.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -99,6 +99,4 @@
 start64:
 	movq (ctx), %rsp
-	pushq $0
-	movq %rsp, %rbp
 	call main_ap - AP_BOOT_OFFSET + BOOT_OFFSET   # never returns
 
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/arm32/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -57,6 +57,4 @@
 	arch/$(KARCH)/src/exception.c \
 	arch/$(KARCH)/src/userspace.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/mm/as.c \
 	arch/$(KARCH)/src/mm/frame.c \
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/arm32/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -34,5 +34,4 @@
 		*(.sdata);
 		*(.reginfo);
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);
Index: kernel/arch/arm32/include/exception.h
===================================================================
--- kernel/arch/arm32/include/exception.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/arm32/include/exception.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -86,5 +86,5 @@
 
 /** Struct representing CPU state saved when an exception occurs. */
-typedef struct istate {
+typedef struct {
 	uint32_t spsr;
 	uint32_t sp;
@@ -133,9 +133,4 @@
 }
 
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return istate->r11;
-}
-
 
 extern void install_exception_handlers(void);
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/arm32/src/mm/page.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -88,5 +88,5 @@
 	    KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH)) {
 		panic("Unable to map physical memory %p (%d bytes).",
-		    physaddr, size);
+		    physaddr, size)
 	}
 	
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -78,6 +78,4 @@
 	arch/$(KARCH)/src/context.S \
 	arch/$(KARCH)/src/debug/panic.s \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/delay.s \
 	arch/$(KARCH)/src/asm.S \
Index: kernel/arch/ia32/_link.ld.in
===================================================================
--- kernel/arch/ia32/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -42,5 +42,4 @@
 		hardcoded_unmapped_kdata_size = .;
 		LONG(unmapped_kdata_end - unmapped_kdata_start);
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);            /* Symbol table, must be LAST symbol! */
Index: kernel/arch/ia32/include/context.h
===================================================================
--- kernel/arch/ia32/include/context.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/include/context.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -49,11 +49,4 @@
 #define SP_DELTA	(8 + STACK_ITEM_SIZE)
 
-#define context_set(c, _pc, stack, size) \
-	do { \
-		(c)->pc = (uintptr_t) (_pc); \
-		(c)->sp = ((uintptr_t) (stack)) + (size) - SP_DELTA; \
-		(c)->ebp = 0; \
-	} while (0)
-
 #endif /* KERNEL */
 
Index: kernel/arch/ia32/include/interrupt.h
===================================================================
--- kernel/arch/ia32/include/interrupt.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/include/interrupt.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -69,9 +69,8 @@
 #define VECTOR_DEBUG_IPI		(IVT_FREEBASE + 2)
 
-typedef struct istate {
+typedef struct {
 	uint32_t eax;
 	uint32_t ecx;
 	uint32_t edx;
-	uint32_t ebp;
 
 	uint32_t gs;
@@ -103,9 +102,4 @@
 }
 
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return istate->ebp;
-}
-
 extern void (* disable_irqs_function)(uint16_t irqmask);
 extern void (* enable_irqs_function)(uint16_t irqmask);
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/src/asm.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -269,5 +269,4 @@
 	pushl %gs
 
-	pushl %ebp
 	pushl %edx
 	pushl %ecx
@@ -279,6 +278,5 @@
 	movw %ax, %es
 
-	# stop stack traces here
-	xorl %ebp, %ebp
+	cld
 
 	pushl %esp          # *istate
@@ -292,5 +290,4 @@
 	popl %ecx
 	popl %edx
-	popl %ebp
 	
 	popl %gs
Index: kernel/arch/ia32/src/boot/boot.S
===================================================================
--- kernel/arch/ia32/src/boot/boot.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/src/boot/boot.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -94,8 +94,4 @@
 	pushl grub_eax
 	call arch_pre_main
-
-	# Create the first stack frame
-	pushl $0
-	movl %esp, %ebp
 	
 	call main_bsp
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/src/interrupt.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -53,5 +53,4 @@
 #include <ddi/irq.h>
 #include <symtab.h>
-#include <stacktrace.h>
 
 /*
@@ -80,6 +79,4 @@
 	printf("stack: %#lx, %#lx, %#lx, %#lx\n", istate->stack[0], istate->stack[1], istate->stack[2], istate->stack[3]);
 	printf("       %#lx, %#lx, %#lx, %#lx\n", istate->stack[4], istate->stack[5], istate->stack[6], istate->stack[7]);
-
-	stack_trace_istate(istate);
 }
 
Index: kernel/arch/ia32/src/mm/page.c
===================================================================
--- kernel/arch/ia32/src/mm/page.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/src/mm/page.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -80,5 +80,5 @@
 {
 	if (last_frame + ALIGN_UP(size, PAGE_SIZE) > KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH))
-		panic("Unable to map physical memory %p (%d bytes).", physaddr, size);
+		panic("Unable to map physical memory %p (%d bytes).", physaddr, size)
 	
 	uintptr_t virtaddr = PA2KA(last_frame);
Index: kernel/arch/ia32/src/smp/ap.S
===================================================================
--- kernel/arch/ia32/src/smp/ap.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia32/src/smp/ap.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -78,7 +78,4 @@
 	addl $0x80000000, %esp			# PA2KA(ctx.sp)
 	
-	pushl $0				# create the first stack frame
-	movl %esp, %ebp
-
 	jmpl $KTEXT, $main_ap
 
Index: kernel/arch/ia64/Makefile.inc
===================================================================
--- kernel/arch/ia64/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -53,6 +53,4 @@
 	arch/$(KARCH)/src/context.S \
 	arch/$(KARCH)/src/cpu/cpu.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/ivt.S \
 	arch/$(KARCH)/src/interrupt.c \
Index: kernel/arch/ia64/_link.ld.in
===================================================================
--- kernel/arch/ia64/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -37,5 +37,4 @@
 		*(COMMON);
 
-		. = ALIGN(8);
                 symbol_table = .;
                 *(symtab.*);            /* Symbol table, must be LAST symbol!*/
Index: kernel/arch/ia64/include/interrupt.h
===================================================================
--- kernel/arch/ia64/include/interrupt.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/include/interrupt.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -72,5 +72,5 @@
 #define EOI  0  /**< The actual value doesn't matter. */
 
-typedef struct istate {
+typedef struct {
 	uint128_t f2;
 	uint128_t f3;
@@ -143,9 +143,4 @@
 }
 
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return 0;	/* FIXME */
-}
-
 static inline int istate_from_uspace(istate_t *istate)
 {
Index: kernel/arch/ia64/include/mm/asid.h
===================================================================
--- kernel/arch/ia64/include/mm/asid.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/include/mm/asid.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -50,16 +50,14 @@
  * but those extra bits are not used by the kernel. 
  */
-#define RIDS_PER_ASID		8
+#define RIDS_PER_ASID		7
 
 #define RID_MAX			262143		/* 2^18 - 1 */
-#define RID_KERNEL7		7
+#define RID_KERNEL		0
+#define RID_INVALID		1
 
-#define ASID2RID(asid, vrn) \
-	((asid) * RIDS_PER_ASID + (vrn))
+#define ASID2RID(asid, vrn)	(((asid)>RIDS_PER_ASID)?(((asid)*RIDS_PER_ASID)+(vrn)):(asid))
+#define RID2ASID(rid)		((rid)/RIDS_PER_ASID)
 
-#define RID2ASID(rid) \
-	((rid) / RIDS_PER_ASID)
-
-#define ASID_MAX_ARCH		(RID_MAX / RIDS_PER_ASID)
+#define ASID_MAX_ARCH		(RID_MAX/RIDS_PER_ASID)
 
 #endif
Index: kernel/arch/ia64/src/mm/page.c
===================================================================
--- kernel/arch/ia64/src/mm/page.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/src/mm/page.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -71,12 +71,26 @@
 
 	/*
-	 * Set up kernel region registers.
-	 * VRN_KERNEL has already been set in start.S.
-	 * For paranoia reasons, we set it again.
+	 * First set up kernel region register.
+	 * This is redundant (see start.S) but we keep it here just for sure.
+	 */
+	rr.word = rr_read(VRN_KERNEL);
+	rr.map.ve = 0;                  /* disable VHPT walker */
+	rr.map.ps = PAGE_WIDTH;
+	rr.map.rid = ASID2RID(ASID_KERNEL, VRN_KERNEL);
+	rr_write(VRN_KERNEL, rr.word);
+	srlz_i();
+	srlz_d();
+
+	/*
+	 * And setup the rest of region register.
 	 */
 	for(i = 0; i < REGION_REGISTERS; i++) {
+		/* skip kernel rr */
+		if (i == VRN_KERNEL)
+			continue;
+	
 		rr.word = rr_read(i);
 		rr.map.ve = 0;		/* disable VHPT walker */
-		rr.map.rid = ASID2RID(ASID_KERNEL, i);
+		rr.map.rid = RID_KERNEL;
 		rr.map.ps = PAGE_WIDTH;
 		rr_write(i, rr.word);
Index: kernel/arch/ia64/src/start.S
===================================================================
--- kernel/arch/ia64/src/start.S	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ia64/src/start.S	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -74,5 +74,5 @@
 	movl r10 = (RR_MASK)
 	and r9 = r10, r9
-	movl r10 = (((RID_KERNEL7) << RID_SHIFT) | (KERNEL_PAGE_WIDTH << PS_SHIFT))
+	movl r10 = ((RID_KERNEL << RID_SHIFT) | (KERNEL_PAGE_WIDTH << PS_SHIFT))
 	or r9 = r10, r9
 	
Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/mips32/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -70,6 +70,4 @@
 	arch/$(KARCH)/src/debugger.c \
 	arch/$(KARCH)/src/cpu/cpu.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/mm/frame.c \
 	arch/$(KARCH)/src/mm/page.c \
Index: kernel/arch/mips32/_link.ld.in
===================================================================
--- kernel/arch/mips32/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/mips32/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -38,5 +38,4 @@
 		*(.bss);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);
Index: kernel/arch/mips32/include/exception.h
===================================================================
--- kernel/arch/mips32/include/exception.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/mips32/include/exception.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -58,5 +58,5 @@
 #define EXC_VCED	31
 
-typedef struct istate {
+typedef struct {
 	uint32_t at;
 	uint32_t v0;
@@ -102,8 +102,4 @@
 	return istate->epc;
 }
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return 0;	/* FIXME */
-}
 
 extern void exception(istate_t *istate);
Index: kernel/arch/ppc32/Makefile.inc
===================================================================
--- kernel/arch/ppc32/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ppc32/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -46,6 +46,4 @@
 	arch/$(KARCH)/src/context.S \
 	arch/$(KARCH)/src/debug/panic.s \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/fpu_context.S \
 	arch/$(KARCH)/src/boot/boot.S \
Index: kernel/arch/ppc32/_link.ld.in
===================================================================
--- kernel/arch/ppc32/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ppc32/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -51,5 +51,4 @@
 		*(COMMON);      /* global variables */
 		
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);    /* Symbol table, must be LAST symbol!*/
Index: kernel/arch/ppc32/include/exception.h
===================================================================
--- kernel/arch/ppc32/include/exception.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ppc32/include/exception.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -39,5 +39,5 @@
 #include <arch/regutils.h>
 
-typedef struct istate {
+typedef struct {
 	uint32_t r0;
 	uint32_t r2;
@@ -98,9 +98,4 @@
 }
 
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return istate->sp;
-}
-
 #endif
 
Index: kernel/arch/ppc32/src/mm/page.c
===================================================================
--- kernel/arch/ppc32/src/mm/page.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/ppc32/src/mm/page.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -51,5 +51,5 @@
 	    KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH))
 		panic("Unable to map physical memory %p (%" PRIs " bytes).",
-		    physaddr, size);
+		    physaddr, size)
 	
 	uintptr_t virtaddr = PA2KA(last_frame);
Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/sparc64/Makefile.inc	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -54,6 +54,4 @@
 ARCH_SOURCES = \
 	arch/$(KARCH)/src/cpu/cpu.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
 	arch/$(KARCH)/src/asm.S \
 	arch/$(KARCH)/src/panic.S \
Index: kernel/arch/sparc64/_link.ld.in
===================================================================
--- kernel/arch/sparc64/_link.ld.in	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/sparc64/_link.ld.in	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -36,5 +36,4 @@
 		*(COMMON);                  /* global variables */
 		
-		. = ALIGN(8);
 		symbol_table = .;
 		*(symtab.*);                /* Symbol table, must be LAST symbol!*/
Index: kernel/arch/sparc64/include/interrupt.h
===================================================================
--- kernel/arch/sparc64/include/interrupt.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/arch/sparc64/include/interrupt.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -50,5 +50,5 @@
 };		
 
-typedef struct istate {
+typedef struct {
 	uint64_t	tnpc;
 	uint64_t	tpc;
@@ -71,9 +71,4 @@
 }
 
-static inline unative_t istate_get_fp(istate_t *istate)
-{
-	return 0;	/* TODO */
-}
-
 #endif
 
Index: kernel/generic/include/interrupt.h
===================================================================
--- kernel/generic/include/interrupt.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/generic/include/interrupt.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -42,5 +42,4 @@
 #include <arch.h>
 #include <ddi/irq.h>
-#include <stacktrace.h>
 
 typedef void (* iroutine)(int n, istate_t *istate);
@@ -50,8 +49,6 @@
 	if (istate_from_uspace(istate)) { \
 		task_t *task = TASK; \
-		printf("Task %s (%" PRIu64 ") killed due to an exception at " \
-		    "program counter %p.\n", task->name, task->taskid, istate_get_pc(istate)); \
-		stack_trace_istate(istate); \
-		printf("Kill message: " fmt "\n", ##__VA_ARGS__); \
+		printf("Task %s (%" PRIu64 ") killed due to an exception at %p: ", task->name, task->taskid, istate_get_pc(istate)); \
+		printf(fmt "\n", ##__VA_ARGS__); \
 		task_kill(task->taskid); \
 		thread_exit(); \
Index: kernel/generic/include/panic.h
===================================================================
--- kernel/generic/include/panic.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/generic/include/panic.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -36,16 +36,8 @@
 #define KERN_PANIC_H_
 
-#include <stacktrace.h>
-#include <print.h>
-
 #ifdef CONFIG_DEBUG
 #	define panic(format, ...) \
-		do { \
-			printf("Kernel panic in %s() at %s:%u.\n", \
-			    __func__, __FILE__, __LINE__); \
-			stack_trace(); \
-			panic_printf("Panic message: " format "\n", \
-			    ##__VA_ARGS__);\
-		} while (0)
+		panic_printf("Kernel panic in %s() at %s:%u: " format "\n", \
+		__func__, __FILE__, __LINE__, ##__VA_ARGS__);
 #else
 #	define panic(format, ...) \
Index: kernel/generic/include/symtab.h
===================================================================
--- kernel/generic/include/symtab.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/generic/include/symtab.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -45,9 +45,9 @@
 };
 
-extern int symtab_name_lookup(uintptr_t, char **, uintptr_t *);
-extern char *symtab_fmt_name_lookup(uintptr_t);
-extern int symtab_addr_lookup(const char *, uintptr_t *);
-extern void symtab_print_search(const char *);
-extern int symtab_compl(char *, size_t);
+extern int symtab_name_lookup(unative_t addr, char **name);
+extern char *symtab_fmt_name_lookup(unative_t addr);
+extern int symtab_addr_lookup(const char *name, uintptr_t *addr);
+extern void symtab_print_search(const char *name);
+extern int symtab_compl(char *input, size_t size);
 
 #ifdef CONFIG_SYMTAB
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ kernel/generic/src/debug/symtab.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -46,7 +46,6 @@
 /** Get name of a symbol that seems most likely to correspond to address.
  *
- * @param addr		Address.
- * @param name		Place to store pointer to the symbol name.
- * @param offset	Place to store offset from the symbol address.
+ * @param addr Address.
+ * @param name Place to store pointer to the symbol name.
  *
  * @return Zero on success or negative error code, ENOENT if not found,
@@ -54,5 +53,5 @@
  *
  */
-int symtab_name_lookup(uintptr_t addr, char **name, uintptr_t *offset)
+int symtab_name_lookup(unative_t addr, char **name)
 {
 #ifdef CONFIG_SYMTAB
@@ -66,7 +65,4 @@
 	if (addr >= uint64_t_le2host(symbol_table[i - 1].address_le)) {
 		*name = symbol_table[i - 1].symbol_name;
-		if (offset)
-			*offset = addr -
-			    uint64_t_le2host(symbol_table[i - 1].address_le);
 		return EOK;
 	}
@@ -92,8 +88,8 @@
  *
  */
-char *symtab_fmt_name_lookup(uintptr_t addr)
+char *symtab_fmt_name_lookup(unative_t addr)
 {
 	char *name;
-	int rc = symtab_name_lookup(addr, &name, NULL);
+	int rc = symtab_name_lookup(addr, &name);
 	
 	switch (rc) {
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/Makefile	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -38,5 +38,4 @@
 	app/init \
 	app/klog \
-	app/mkfat \
 	app/redir \
 	app/tester \
Index: uspace/app/bdsh/Makefile.build
===================================================================
--- uspace/app/bdsh/Makefile.build	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/app/bdsh/Makefile.build	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -42,5 +42,4 @@
 	cmds/modules/help/help.c \
 	cmds/modules/mkdir/mkdir.c \
-	cmds/modules/mkfile/mkfile.c \
 	cmds/modules/rm/rm.c \
 	cmds/modules/bdd/bdd.c \
Index: uspace/app/bdsh/cmds/modules/modules.h
===================================================================
--- uspace/app/bdsh/cmds/modules/modules.h	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/app/bdsh/cmds/modules/modules.h	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -20,5 +20,4 @@
 #include "help/entry.h"
 #include "mkdir/entry.h"
-#include "mkfile/entry.h"
 #include "rm/entry.h"
 #include "bdd/entry.h"
@@ -40,5 +39,4 @@
 #include "help/help_def.h"
 #include "mkdir/mkdir_def.h"
-#include "mkfile/mkfile_def.h"
 #include "rm/rm_def.h"
 #include "bdd/bdd_def.h"
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/app/edit/edit.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -98,5 +98,4 @@
 static bool done;
 static pane_t pane;
-static bool cursor_visible;
 
 static int scr_rows, scr_columns;
@@ -109,8 +108,4 @@
 /** Maximum filename length that can be entered. */
 #define INFNAME_MAX_LEN 128
-
-static void cursor_show(void);
-static void cursor_hide(void);
-static void cursor_setvis(bool visible);
 
 static void key_handle_unmod(console_event_t const *ev);
@@ -204,7 +199,4 @@
 
 	/* Initial display */
-	cursor_visible = true;
-
-	cursor_hide();
 	console_clear(con);
 	pane_text_display();
@@ -213,5 +205,5 @@
 		status_display("File not found. Starting empty file.");
 	pane_caret_display();
-	cursor_show();
+
 
 	done = false;
@@ -238,6 +230,4 @@
 		/* Redraw as necessary. */
 
-		cursor_hide();
-
 		if (pane.rflags & REDRAW_TEXT)
 			pane_text_display();
@@ -248,6 +238,4 @@
 		if (pane.rflags & REDRAW_CARET)
 			pane_caret_display();
-
-		cursor_show();
 	}
 
@@ -255,22 +243,4 @@
 
 	return 0;
-}
-
-static void cursor_show(void)
-{
-	cursor_setvis(true);
-}
-
-static void cursor_hide(void)
-{
-	cursor_setvis(false);
-}
-
-static void cursor_setvis(bool visible)
-{
-	if (cursor_visible != visible) {
-		console_cursor_visibility(con, visible);
-		cursor_visible = visible;
-	}
 }
 
Index: uspace/lib/libblock/libblock.c
===================================================================
--- uspace/lib/libblock/libblock.c	(revision 439ba779b5b1aca3fc5c7ccec9f9a527dd0a1300)
+++ uspace/lib/libblock/libblock.c	(revision 9dcadb0c1cb41cc1dbb0a9f07391639a295754e4)
@@ -87,5 +87,4 @@
 static int write_blocks(devcon_t *devcon, bn_t ba, size_t cnt);
 static int get_block_size(int dev_phone, size_t *bsize);
-static int get_num_blocks(int dev_phone, bn_t *nblocks);
 
 static devcon_t *devcon_search(dev_handle_t dev_handle)
@@ -715,5 +714,5 @@
 
 	memcpy(devcon->comm_area, data, devcon->pblock_size * cnt);
-	rc = write_blocks(devcon, ba, cnt);
+	rc = read_blocks(devcon, ba, cnt);
 
 	fibril_mutex_unlock(&devcon->comm_area_lock);
@@ -737,21 +736,4 @@
 	
 	return get_block_size(devcon->dev_phone, bsize);
-}
-
-/** Get number of blocks on device.
- *
- * @param dev_handle	Device handle of the block device.
- * @param nblocks	Output number of blocks.
- *
- * @return		EOK on success or negative error code on failure.
- */
-int block_get_nblocks(dev_handle_t dev_handle, bn_t *nblocks)
-{
-	devcon_t *devcon;
-
-	devcon = devcon_search(dev_handle);
-	assert(devcon);
-	
-	return get_num_blocks(devcon->dev_phone, nblocks);
 }
 
@@ -807,18 +789,4 @@
 }
 
-/** Get total number of blocks on block device. */
-static int get_num_blocks(int dev_phone, bn_t *nblocks)
-{
-	ipcarg_t nb_l, nb_h;
-	int rc;
-
-	rc = async_req_0_2(dev_phone, BD_GET_NUM_BLOCKS, &nb_l, &nb_h);
-	if (rc == EOK) {
-		*nblocks = (bn_t) MERGE_LOUP32(nb_l, nb_h);
-	}
-
-	return rc;
-}
-
 /** @}
  */
